
#if !defined(AVM_PLUS_H_)
#define AVM_PLUS_H_

#include <cstddef>
#include <stdint.h>
#include <cstdio>
#include <cstring>
#include <math.h>
#include <cstdarg>
#include <stdlib.h>
#include <ctype.h>

#include "LirHelper.h"

#define FEATURE_NANOJIT

#if defined(_M_X64) || (defined(__LP64__) || defined(_LP64)) 
//#define NANOJIT_64BIT
#define AVMPLUS_64BIT
#define AVMPLUS_AMD64
#elif defined(__ppc__)
#define AVMPLUS_PPC
#else
#define AVMPLUS_IA32
#define AVMPLUS_WIN32
#endif

#define VMPI_abort abort
#define VMPI_strlen strlen
#define VMPI_strcat strcat
#define VMPI_strcmp strcmp
#define VMPI_strncat strncat
#define VMPI_strcpy strcpy
#define VMPI_sprintf sprintf
#ifdef _MSC_VER
#   define VMPI_snprintf sprintf_s
#else
#   define VMPI_snprintf snprintf
#endif
#define VMPI_vfprintf vfprintf
#define VMPI_memset memset
#define VMPI_memcmp memcmp
#define VMPI_isdigit isdigit
#define VMPI_getDate()


namespace avmplus
{
	void AvmLog(const char* a_sMessage, ...);
	void AvmAssertFail(const char* a_sMessage);
	void AvmBreak();

	template<typename T>
	unsigned int AvmCountBitSet(T a_iValue);

	template<typename T>
	unsigned int AvmCountLeadingZeros(T a_iValue);

}

#define AVMPLUS_FORCEINLINE inline

#include "float4Support.h"

#define PERFM_NVPROF(...) do { } while(false)

#if defined(_MSC_VER)
#pragma warning(disable: 4291)
#endif

#endif // AVM_PLUS_H_
